#include <math.h>
#include "dsk6713.h"
#include "dsk6713_aic23.h"
#define pi 3.141592653589
#define NUM_TRACKS 4
#define NUM_TONE_SLOTS 128
int slotLen=7200; //num of samples of shortest tone/pause; preset at 1/8 note per slot @ 200 BPM of 1/4 note

struct tone{
  double freq;
  double amp;};
struct tone to[NUM_TRACKS][NUM_TONE_SLOTS];

/* Codec configuration settings */
static DSK6713_AIC23_Config config = { \
    0x0017,  /* 0 DSK6713_AIC23_LEFTINVOL  Left line input channel volume 0dB*/ \
    0x0017,  /* 1 DSK6713_AIC23_RIGHTINVOL Right line input channel volume 0dB*/\
    0x00f9,  /* 2 DSK6713_AIC23_LEFTHPVOL  Left channel headphone volume 0dB*/  \
    0x00f9,  /* 3 DSK6713_AIC23_RIGHTHPVOL Right channel headphone volume 0dB*/ \
    0x0011,  /* 4 DSK6713_AIC23_ANAPATH    Analog audio path control    */      \
    0x0000,  /* 5 DSK6713_AIC23_DIGPATH    Digital audio path control    */     \
    0x0000,  /* 6 DSK6713_AIC23_POWERDOWN  Power down control    */             \
    0x0043,  /* 7 DSK6713_AIC23_DIGIF      Digital audio interface format    */ \
    0x0081,  /* 8 DSK6713_AIC23_SAMPLERATE Sample rate control    */            \
    0x0001   /* 9 DSK6713_AIC23_DIGACT     Digital interface activation    */   \
};

/*
 * main.c
 */
int main(void) {
  DSK6713_AIC23_CodecHandle hCodec;
  // Initialize the board support library, must be called first
  DSK6713_init();
  // Start the codec
  hCodec = DSK6713_AIC23_openCodec(0, &config);

  // initialize variables
  int i, k, m, n;
  short out;
  double freqA, freqB, freqC, freqD, ampA, ampB, ampC, ampD, x, argA, argB, argC, argD;
  double fs = 48000;
  double T = 1/fs;
  double a = 2*pi;
  double b = a *T;
  slotLen = 9000;
  x = 0.0;
  // works with next line active, further 2 lines commented, doesn't work vice versa
  //argA = argB = argC = argD = 0.0;
  argA = 0.0;
  argB = argC = argD = 0.0;

  // define the song
  for(m=0 ; m<NUM_TRACKS ; m++) {
    for(n=0 ; n<NUM_TONE_SLOTS ; n++) {
      to[m][n].freq = 0.0;
      if(m == 3) to[m][n].amp = 3000;
      else to[m][n].amp = 1000;}
  }

  /******** 1. Takt *********/
  to[0][0].freq = 329.627557;
  to[1][0].freq = 261.625565;
  to[2][0].freq = 195.997718;
  to[3][0].freq = 130.812783;

  to[0][1].freq = 329.627557;
  to[1][1].freq = 261.625565;
  to[2][1].freq = 195.997718;
  to[3][1].freq = 130.812783;

  to[0][2].freq = 329.627557;
  to[1][2].freq = 261.625565;
  to[2][2].freq = 195.997718;
  to[3][2].freq = 130.812783;

  to[0][3].freq = 329.627557;
  to[1][3].freq = 261.625565;
  to[2][3].freq = 195.997718;
  to[3][3].freq = 130.812783;

  to[0][4].freq = 329.627557;
  to[1][4].freq = 261.625565;
  to[2][4].freq = 195.997718;

  to[0][5].freq = 329.627557;
  to[1][5].freq = 261.625565;
  to[2][5].freq = 195.997718;

  to[0][6].freq = 329.627557;
  to[1][6].freq = 261.625565;
  to[2][6].freq = 195.997718;
  to[3][6].freq = 130.812783;

  to[0][7].freq = 329.627557;
  to[1][7].freq = 261.625565;
  to[2][7].freq = 195.997718;
  to[3][7].freq = 130.812783;

  to[0][8].freq = 329.627557;
  to[1][8].freq = 261.625565;
  to[2][8].freq = 195.997718;
  to[3][8].freq = 123.470825;

  to[0][9].freq = 329.627557;
  to[1][9].freq = 261.625565;
  to[2][9].freq = 195.997718;
  to[3][9].freq = 123.470825;

  to[0][10].freq = 329.627557;
  to[1][10].freq = 261.625565;
  to[2][10].freq = 195.997718;
  to[3][10].freq = 123.470825;

  to[0][11].freq = 329.627557;
  to[1][11].freq = 261.625565;
  to[2][11].freq = 195.997718;
  to[3][11].freq = 123.470825;

  to[0][12].freq = 329.627557;
  to[1][12].freq = 261.625565;
  to[2][12].freq = 195.997718;

  to[0][13].freq = 329.627557;
  to[1][13].freq = 261.625565;
  to[2][13].freq = 195.997718;

  to[0][14].freq = 329.627557;
  to[1][14].freq = 261.625565;
  to[2][14].freq = 195.997718;
  to[3][14].freq = 123.470825;

  to[0][15].freq = 329.627557;
  to[1][15].freq = 261.625565;
  to[2][15].freq = 195.997718;
  to[3][15].freq = 123.470825;

  /******** 1. Takt Ende *********/

  /******** 2. Takt *********/

  to[0][16].freq = 329.627557;
  to[1][16].freq = 261.625565;
  to[2][16].freq = 195.997718;
  to[3][16].freq = 110.0;

  to[0][17].freq = 329.627557;
  to[1][17].freq = 261.625565;
  to[2][17].freq = 195.997718;
  to[3][17].freq = 110.0;

  to[0][18].freq = 293.664768;
  to[1][18].freq = 0.0;
  to[2][18].freq = 195.997718;
  to[3][18].freq = 110.0;

  to[0][19].freq = 293.664768;
  to[1][19].freq = 0.0;
  to[2][19].freq = 195.997718;
  to[3][19].freq = 110.0;

  to[0][20].freq=261.625565; //c up1
  to[2][20].freq=195.997718; //g small

  to[0][21].freq=261.625565; //c up1
  to[2][21].freq=195.997718; //g small

  to[0][22].freq=246.941651; //h small
  to[2][22].freq=195.997718; //g small
  to[3][22].freq=110.0;      //a big

  to[0][23].freq=246.941651; //h small
  to[2][23].freq=195.997718; //g small
  to[3][23].freq=110.0;      //a big


  to[0][24].freq=261.625565; //c up1
  to[2][24].freq=195.997718; //g small
  to[3][24].freq=97.998859; //g big

  to[0][25].freq=261.625565; //c up1
  to[2][25].freq=195.997718; //g small
  to[3][25].freq=97.998859; //g big


  to[0][26].freq=293.664768; //d up1
  to[2][26].freq=195.997718; //g small
  to[3][26].freq=97.998859; //g big

  to[0][27].freq=293.664768; //d up1
  to[2][27].freq=195.997718; //g small
  to[3][27].freq=97.998859; //g big

  to[0][28].freq=329.627557; //e up1
  to[2][28].freq=195.997718; //g small

  to[0][29].freq=329.627557; //e up1
  to[2][29].freq=195.997718; //g small

  to[0][30].freq=261.625565; //c up1
  to[2][30].freq=195.997718; //g small
  to[3][30].freq=97.998859; //g big

  to[0][31].freq=261.625565; //c up1
  to[2][31].freq=195.997718; //g small
  to[3][31].freq=97.998859; //g big

  /******** 2. Takt Ende*********/

  /******** 3. Takt *********/

  to[0][32].freq=440; //a up1
  to[1][32].freq=349.228231; //f up1
  to[2][32].freq=261.625565; //c up1
  to[3][32].freq=87.307058; //f big

  to[0][33].freq=440; //a up1
  to[1][33].freq=349.228231; //f up1
  to[2][33].freq=261.625565; //c up1
  to[3][33].freq=87.307058; //f big

  to[0][34].freq=440; //a up1
  to[1][34].freq=349.228231; //f up1
  to[2][34].freq=261.625565; //c up1
  to[3][34].freq=87.307058; //f big

  to[0][35].freq=440; //a up1
  to[1][35].freq=349.228231; //f up1
  to[2][35].freq=261.625565; //c up1
  to[3][35].freq=87.307058; //f big

  to[0][36].freq=440; //a up1
  to[1][36].freq=349.228231; //f up1
  to[2][36].freq=261.625565; //c up1

  to[0][37].freq=440; //a up1
  to[1][37].freq=349.228231; //f up1
  to[2][37].freq=261.625565; //c up1

  to[0][38].freq=440; //a up1
  to[1][38].freq=349.228231; //f up1
  to[2][38].freq=261.625565; //c up1
  to[3][38].freq=87.307058; //f big

  to[0][39].freq=440; //a up1
  to[1][39].freq=349.228231; //f up1
  to[2][39].freq=261.625565; //c up1
  to[3][39].freq=87.307058; //f big

  to[0][40].freq=440; //a up1
  to[1][40].freq=349.228231; //f up1
  to[2][40].freq=261.625565; //c up1
  to[3][40].freq=82.406889; //e big

  to[0][41].freq=440; //a up1
  to[1][41].freq=349.228231; //f up1
  to[2][41].freq=261.625565; //c up1
  to[3][41].freq=82.406889; //e big

  to[0][42].freq=440; //a up1
  to[1][42].freq=349.228231; //f up1
  to[2][42].freq=261.625565; //c up1
  to[3][42].freq=82.406889; //e big

  to[0][43].freq=440; //a up1
  to[1][43].freq=349.228231; //f up1
  to[2][43].freq=261.625565; //c up1
  to[3][43].freq=82.406889; //e big

  to[0][44].freq=493.883301; //h up1
  to[1][44].freq=349.228231; //f up1
  to[2][44].freq=261.625565; //c up1

  to[0][45].freq=493.883301; //h up1
  to[1][45].freq=349.228231; //f up1
  to[2][45].freq=261.625565; //c up1

  to[0][46].freq=523.251131; //c up2
  to[1][46].freq=349.228231; //f up1
  to[2][46].freq=261.625565; //c up1
  to[3][46].freq=82.406889; //e big

  to[0][47].freq=523.251131; //c up2
  to[1][47].freq=349.228231; //f up1
  to[2][47].freq=261.625565; //c up1
  to[3][47].freq=82.406889; //e big

  /******** 3. Takt Ende *********/

  /******** 4. Takt *********/

  to[0][48].freq=349.228231; //f up1
  to[1][48].freq=293.664768; //d up1
  to[2][48].freq=261.625565; //c up1
  to[3][48].freq=73.416192;  //d big

  to[0][49].freq=329.627557; //e up1
  to[1][49].freq=293.664768; //d up1
  to[2][49].freq=261.625565; //c up1
  to[3][49].freq=73.416192;  //d big

  to[0][50].freq=349.228231; //f up1
  to[1][50].freq=293.664768; //d up1
  to[2][50].freq=261.625565; //c up1
  to[3][50].freq=73.416192;  //d big

  to[0][51].freq=349.228231; //f up1
  to[1][51].freq=293.664768; //d up1
  to[2][51].freq=261.625565; //c up1
  to[3][51].freq=73.416192;  //d big

  to[0][52].freq=349.228231; //f up1
  to[1][52].freq=293.664768; //d up1
  to[2][52].freq=261.625565; //c up1

  to[0][53].freq=349.228231; //f up1
  to[1][53].freq=293.664768; //d up1
  to[2][53].freq=261.625565; //c up1

  to[0][54].freq=349.228231; //f up1
  to[1][54].freq=293.664768; //d up1
  to[2][54].freq=261.625565; //c up1
  to[3][54].freq=73.416192;  //d big

  to[0][55].freq=349.228231; //f up1
  to[1][55].freq=293.664768; //d up1
  to[2][55].freq=261.625565; //c up1
  to[3][55].freq=73.416192;  //d big

  to[0][56].freq=349.228231; //f up1
  to[1][56].freq=293.664768; //d up1
  to[2][56].freq=261.625565; //c up1
  to[3][56].freq=65.406391; //c big

  to[0][57].freq=349.228231; //f up1
  to[1][57].freq=293.664768; //d up1
  to[2][57].freq=261.625565; //c up1
  to[3][57].freq=65.406391; //c big

  to[0][58].freq=349.228231; //f up1
  to[1][58].freq=293.664768; //d up1
  to[2][58].freq=261.625565; //c up1
  to[3][58].freq=65.406391; //c big

  to[0][59].freq=349.228231; //f up1
  to[1][59].freq=293.664768; //d up1
  to[2][59].freq=261.625565; //c up1
  to[3][59].freq=65.406391; //c big

  to[0][60].freq=293.664768; //d up1
  to[1][60].freq=293.664768; //d up1
  to[2][60].freq=261.625565; //c up1

  to[0][61].freq=293.664768; //d up1
  to[1][61].freq=293.664768; //d up1
  to[2][61].freq=261.625565; //c up1

  to[0][62].freq=293.664768; //d up1
  to[1][62].freq=293.664768; //d up1
  to[2][62].freq=261.625565; //c up1
  to[3][62].freq=65.406391; //c big

  to[0][63].freq=293.664768; //d up1
  to[1][63].freq=293.664768; //d up1
  to[2][63].freq=261.625565; //c up1
  to[3][63].freq=65.406391; //c big

  /******** 4. Takt  Ende *********/

  /******** 5. Takt *********/

  to[0][64].freq = 493.883301;
  to[1][64].freq = 391.995436;
  to[2][64].freq = 293.664768;
  to[3][64].freq = 97.998859;

  to[0][65].freq = 493.883301;
  to[1][65].freq = 391.995436;
  to[2][65].freq = 293.664768;
  to[3][65].freq = 97.998859;

  to[0][66].freq = 493.883301;
  to[1][66].freq = 391.995436;
  to[2][66].freq = 293.664768;
  to[3][66].freq = 97.998859;

  to[0][67].freq = 493.883301;
  to[1][67].freq = 391.995436;
  to[2][67].freq = 293.664768;
  to[3][67].freq = 97.998859;

  to[0][68].freq = 493.883301;
  to[1][68].freq = 391.995436;
  to[2][68].freq = 293.664768;

  to[0][69].freq = 493.883301;
  to[1][69].freq = 391.995436;
  to[2][69].freq = 293.664768;

  to[0][70].freq = 493.883301;
  to[1][70].freq = 391.995436;
  to[2][70].freq = 293.664768;
  to[3][70].freq = 97.998859;

  to[0][71].freq = 493.883301;
  to[1][71].freq = 391.995436;
  to[2][71].freq = 293.664768;
  to[3][71].freq = 97.998859;

  to[0][72].freq = 493.883301;
  to[1][72].freq = 391.995436;
  to[2][72].freq = 293.664768;
  to[3][72].freq = 87.307058;

  to[0][73].freq = 493.883301;
  to[1][73].freq = 391.995436;
  to[2][73].freq = 293.664768;
  to[3][73].freq = 87.307058;

  to[0][74].freq = 493.883301;
  to[1][74].freq = 391.995436;
  to[2][74].freq = 293.664768;
  to[3][74].freq = 87.307058;

  to[0][75].freq = 493.883301;
  to[1][75].freq = 391.995436;
  to[2][75].freq = 293.664768;
  to[3][75].freq = 87.307058;

  to[0][76].freq = 523.251131;
  to[1][76].freq = 391.995436;
  to[2][76].freq = 293.664768;

  to[0][77].freq = 523.251131;
  to[1][77].freq = 391.995436;
  to[2][77].freq = 293.664768;

  to[0][78].freq = 587.329536;
  to[1][78].freq = 391.995436;
  to[2][78].freq = 293.664768;
  to[3][78].freq = 87.307058;

  to[0][79].freq = 587.329536;
  to[1][79].freq = 391.995436;
  to[2][79].freq = 293.664768;
  to[3][79].freq = 87.307058;

  /******** 5. Takt Ende *********/

  /******** 6. Takt *********/

  to[0][80].freq = 391.995436;
  to[1][80].freq = 329.627557;
  to[2][80].freq = 246.941651;
  to[3][80].freq = 82.406889;

  to[0][81].freq = 349.228231;
  to[1][81].freq = 329.627557;
  to[2][81].freq = 246.941651;
  to[3][81].freq = 82.406889;

  to[0][82].freq = 391.995436;
  to[1][82].freq = 329.627557;
  to[2][82].freq = 246.941651;
  to[3][82].freq = 82.406889;

  to[0][83].freq = 391.995436;
  to[1][83].freq = 329.627557;
  to[2][83].freq = 246.941651;
  to[3][83].freq = 82.406889;

  to[0][84].freq = 391.995436;
  to[1][84].freq = 329.627557;
  to[2][84].freq = 246.941651;

  to[0][85].freq = 391.995436;
  to[1][85].freq = 329.627557;
  to[2][85].freq = 246.941651;

  to[0][86].freq = 391.995436;
  to[1][86].freq = 329.627557;
  to[2][86].freq = 246.941651;
  to[3][86].freq = 82.406889;

  to[0][87].freq = 391.995436;
  to[1][87].freq = 329.627557;
  to[2][87].freq = 246.941651;
  to[3][87].freq = 82.406889;

  to[0][88].freq = 391.995436;
  to[2][88].freq = 246.941651;
  to[3][88].freq = 73.416192;

  to[0][89].freq = 391.995436;
  to[2][89].freq = 246.941651;
  to[3][89].freq = 73.416192;

  to[0][90].freq = 349.228231;
  to[2][90].freq = 246.941651;
  to[3][90].freq = 73.416192;

  to[0][91].freq = 349.228231;
  to[2][91].freq = 246.941651;
  to[3][91].freq = 73.416192;

  to[0][92].freq = 329.627557;
  to[2][92].freq = 246.941651;

  to[0][93].freq = 329.627557;
  to[2][93].freq = 246.941651;

  to[0][94].freq = 349.228231;
  to[2][94].freq = 246.941651;
  to[3][94].freq = 73.416192;

  to[0][95].freq = 349.228231;
  to[2][95].freq = 246.941651;
  to[3][95].freq = 73.416192;

  /******** 6. Takt Ende *********/

  /******** 7. Takt *********/

  to[0][96].freq = 349.228231;
  to[1][96].freq = 261.625565;
  to[2][96].freq = 195.997718;
  to[3][96].freq = 65.406391;

  to[0][97].freq = 349.228231;
  to[1][97].freq = 261.625565;
  to[2][97].freq = 195.997718;
  to[3][97].freq = 65.406391;

  to[0][98].freq = 329.627557;
  to[1][98].freq = 261.625565;
  to[2][98].freq = 195.997718;
  to[3][98].freq = 65.406391;

  to[0][99].freq = 329.627557;
  to[1][99].freq = 261.625565;
  to[2][99].freq = 195.997718;
  to[3][99].freq = 65.406391;

  to[0][100].freq = 293.664768;
  to[1][100].freq = 261.625565;
  to[2][100].freq = 195.997718;
  to[3][100].freq = 82.406889;

  to[0][101].freq = 293.664768;
  to[1][101].freq = 261.625565;
  to[2][101].freq = 195.997718;
  to[3][101].freq = 82.406889;

  to[0][102].freq = 261.625565;
  to[1][102].freq = 261.625565;
  to[2][102].freq = 195.997718;
  to[3][102].freq = 82.406889;

  to[0][103].freq = 261.625565;
  to[1][103].freq = 261.625565;
  to[2][103].freq = 195.997718;
  to[3][103].freq = 82.406889;

  to[0][104].freq = 261.625565;
  to[1][104].freq = 440.0;
  to[2][104].freq = 349.228231;
  to[3][104].freq = 87.307058;

  to[0][105].freq = 261.625565;
  to[1][105].freq = 440.0;
  to[2][105].freq = 349.228231;
  to[3][105].freq = 87.307058;

  to[0][106].freq = 293.664768;
  to[1][106].freq = 440.0;
  to[2][106].freq = 349.228231;
  to[3][106].freq = 87.307058;

  to[0][107].freq = 293.664768;
  to[1][107].freq = 440.0;
  to[2][107].freq = 349.228231;
  to[3][107].freq = 87.307058;

  to[0][108].freq = 329.627557;
  to[1][108].freq = 440.0;
  to[2][108].freq = 349.228231;

  to[0][109].freq = 329.627557;
  to[1][109].freq = 440.0;
  to[2][109].freq = 349.228231;

  to[0][110].freq = 349.228231;
  to[1][110].freq = 440.0;
  to[2][110].freq = 349.228231;
  to[3][110].freq = 87.307058;

  to[0][111].freq = 349.228231;
  to[1][111].freq = 440.0;
  to[2][111].freq = 349.228231;
  to[3][111].freq = 87.307058;

  /******** 7. Takt Ende *********/

  /******** 8. Takt *********/

  to[0][112].freq = 391.995436;
  to[1][112].freq = 246.941651;
  to[3][112].freq = 97.998859;

  to[0][113].freq = 391.995436;
  to[1][113].freq = 246.941651;
  to[3][113].freq = 97.998859;

  to[0][114].freq = 391.995436;
  to[1][114].freq = 261.625565;
  to[3][114].freq = 97.998859;

  to[0][115].freq = 391.995436;
  to[1][115].freq = 261.625565;
  to[3][115].freq = 97.998859;

  to[0][116].freq = 391.995436;
  to[1][116].freq = 293.664768;
  to[3][116].freq = 97.998859;

  to[0][117].freq = 391.995436;
  to[1][117].freq = 293.664768;
  to[3][117].freq = 97.998859;

  to[0][118].freq = 391.995436;
  to[1][118].freq = 329.627557;
  to[3][118].freq = 97.998859;

  to[0][119].freq = 391.995436;
  to[1][119].freq = 329.627557;
  to[3][119].freq = 97.998859;

  to[1][120].freq = 349.228231;    //strange: doesn't work till end of song, needs to comment part
  to[2][120].freq = 261.625565;
  /*to[3][120].freq = 110.0;

  to[1][121].freq = 349.228231;
  to[2][121].freq = 261.625565;
  to[3][121].freq = 110.0;

  to[1][122].freq = 329.627557;
  to[2][122].freq = 261.625565;
  to[3][122].freq = 110.0;

  to[1][123].freq = 329.627557;
  to[2][123].freq = 261.625565;
  to[3][123].freq = 110.0;

  to[1][124].freq = 349.228231;
  to[2][124].freq = 195.997718;
  to[3][124].freq = 123.470825;

  to[1][125].freq = 349.228231;
  to[2][125].freq = 195.997718;
  to[3][125].freq = 123.470825;

  to[1][126].freq = 329.627557;
  to[2][126].freq = 195.997718;
  to[3][126].freq = 123.470825;

  to[1][127].freq = 329.627557;
  to[2][127].freq = 195.997718;
  to[3][127].freq = 123.470825;
  */

  // generating the song
  for(;;){
    for(i=0; i<NUM_TONE_SLOTS;i++){
      freqA = to[0][i].freq;
      ampA = to[0][i].amp;
      freqB = to[1][i].freq;
      ampB = to[1][i].amp;
      freqC = to[2][i].freq;
      ampC = to[2][i].amp;
      freqD = to[3][i].freq;
      ampD = to[3][i].amp;

      for(k=0; k <= slotLen ; k++){
        x = 0.0;

        argA = argA + (b*freqA);
        if(argA >= a){
          argA = argA -a;}
        x = x + ampA *sin(argA);


        argB= argB + (b*freqB);
        if(argB >= a){
          argB = argB - a;}
        x = x + ampB *sin(argB);

        argC= argC + (b*freqC);
        if(argC >= a){
          argC = argC - a;}
        x = x + ampC *sin(argC);

        argD= argD + (b*freqD);
        if(argD >= a){
          argD = argD - a;}
        x = x + ampD *sin(argD);

        out = (short) x ;
        /* Send a sample to the left channel */
        while (!DSK6713_AIC23_write(hCodec, out));
        /* Send a sample to the right channel */
        while (!DSK6713_AIC23_write(hCodec, out));
      }
    }
  }

  // Close the codec
  DSK6713_AIC23_closeCodec(hCodec);
  return 0;
}
